pro do_darksub,refimage,refimage_short,specimage,specimage_short, $
               superdark,refdark_long,refdark_short,$
               refimage_hs,refimage_hs_short,specimage_hs,specimage_hs_short, $
;              hotpix=hotpix, $
               superdark_combined=superdark_combined,refdark_combined=refdark_combined,hotpix_image=hotpix_image

  common gui,logger

  if defined(logger) then logger->append,['---','Dark subtracting...']
  
  if !IRC_SPECRED_OBSPARAM.preflight_mode then begin
     refimage_ds=      refimage
     refimage_ds_short=refimage_short
     specimage_ds=      specimage
     specimage_ds_short=specimage_short
     return
  endif

; new for phase-3
  if !IRC_SPECRED_PROCESSOPTION.warm_mode EQ 1 && !IRC_SPECRED_PROCESSOPTION.aot64_mode NE 1 then begin
     ; use all 4 dark frames (after phase-3)
     refdark_short_pre=refdark_short[*,*,0:3]
     refdark_long_pre=refdark_long[*,*,0:3]
   endif else begin
;
;
     ; use only the first dark fame (before phase-3)
     refdark_short_pre=refdark_short[*,*,0]
     if NIR() then refdark_long_pre=refdark_long[*,*,0] else refdark_long_pre=refdark_long[*,*,0:2]
  endelse
; end of 'new for phase3'

  if !IRC_SPECRED_PROCESSOPTION.warm_mode EQ 0 then begin ; cold mode
     irc_darksub,refimage_short, superdark,refdark_short_pre,refimage_ds_short,/short, $
                 /scale_dark,scaled_dark=scaled_dark_short
     irc_darksub,refimage,       superdark,refdark_long_pre,refimage_ds, $
                 /scale_dark,scaled_dark=scaled_dark
     
     irc_darksub,specimage_short,superdark,refdark_short_pre,specimage_ds_short,/short, $
                 /scale_dark,scaled_dark=scaled_dark_short
     irc_darksub,specimage,      superdark,refdark_long_pre,specimage_ds, $
                 /scale_dark,scaled_dark=scaled_dark

     irc_darksub,refdark_short,superdark,refdark_short_pre,refdark_ds_short,/short, $
                 /scale_dark,scaled_dark=scaled_dark_short
     irc_darksub,refdark_long, superdark,refdark_long_pre,refdark_ds_long, $
                 /scale_dark,scaled_dark=scaled_dark
     
     If !IRC_SPECRED_OBSPARAM.Np_mode && !IRC_SPECRED_PROCESSOPTION.fine_darksub_at_Np_mode then begin
        irc_darkfeature_sub,specimage_ds,specimage_ds_dfs
        specimage_ds=specimage_ds_dfs
     endif
;
; do hotpixel subtraction
;
     do_hotpixsub,refimage_ds,refimage_ds_short,specimage_ds,specimage_ds_short, $
                  refdark_ds_long,refdark_ds_short,superdark, $
                  refimage_hs,specimage_hs,hotpix=hotpix

     refimage_hs_short=refimage_short
     specimage_hs_short=specimage_short
 
  endif else begin              ; new for phase-3

     do_hotpixsub_p3,refimage,refimage_short,specimage,specimage_short, $
                     refdark_long,refdark_short,refdark_long_pre,refdark_short_pre,refdark_combined, $
                     flicker_mask,hotpix_mask,$
                     hotpix=hotpix

; dummy
     refimage_hs_short=refimage_short
     refimage_hs=refimage
     specimage_hs_short=specimage_short
     specimage_hs=specimage

     s=size(refimage_short)
     if s[0] EQ 2 then n_frame=1 else n_frame=s[3]
     for i=0,n_frame-1 do refimage_hs_short[*,*,i]=(refimage_short[*,*,i]-refdark_combined[*,*,0])*flicker_mask*1.0*hotpix_mask

     s=size(specimage_short)
     if s[0] EQ 2 then n_frame=1 else n_frame=s[3]
     for i=0,n_frame-1 do specimage_hs_short[*,*,i]=(specimage_short[*,*,i]-refdark_combined[*,*,0])*flicker_mask*1.0*hotpix_mask

     s=size(specimage)
     if s[0] EQ 2 then n_frame=1 else n_frame=s[3]
     for i=0,n_frame-1 do specimage_hs[*,*,i]=(specimage[*,*,i]-refdark_combined[*,*,1])*flicker_mask*1.0*hotpix_mask
;     print,specimage_ds[310,234,*]

     s=size(refimage)
     if s[0] EQ 2 then n_frame=1 else n_frame=s[3]
     for i=0,n_frame-1 do refimage_hs[*,*,i]=(refimage[*,*,i]-refdark_combined[*,*,1])*flicker_mask*1.0*hotpix_mask
;     atv,refimage_ds,/b,max=100,min=-100
     
  endelse                       ; warm mode processing ends

end
